#include <iostream>
using namespace std;

#define MAX 50

struct _aluno {
    int matricula;
    float nota;
};

int empilhar(struct _aluno v[], int &topo, struct _aluno aluno);
int desempilhar(struct _aluno[], int &topo, struct _aluno &aluno);

int main(void) {
    // Declara um aluno
    struct _aluno alunos[MAX];
    int talunos = -1;
    struct _aluno temp;

    temp.matricula = 12014432;
    temp.nota = 7.5;
    empilhar(alunos, talunos, temp);

    temp.matricula = 13022301;
    temp.nota = 5.7;
    empilhar(alunos, talunos, temp);

    temp.matricula = 11024122;
    temp.nota = 9.0;
    empilhar(alunos, talunos, temp);

    while(desempilhar(alunos, talunos, temp) == 0) {
        cout << "Mat.: " << temp.matricula << endl;
        cout << "Nota: " << temp.nota << endl;
    }


}

// Empilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: valor a ser empilhado
// Retorna:
//  1- Se pilha cheia
//  0- Caso contrrio
int empilhar(struct _aluno v[], int &topo, struct _aluno valor) {
    // Se a pilha est cheia... retorna 1
    if (topo>=MAX-1) {
        cout << "ERRO: Pilha cheia!" << endl;
        return 1;
    }
    // Se pilha no est cheia, vamos empilhar
    topo = topo + 1;
    v[topo] = valor;
    // Indica que valor foi empilhado
    return 0;
}


// Desempilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: Local a colocar valor desempilhado
// Retorna:
//  valor: valor desempilhado
//  1- Se pilha vazia
//  0- Caso contrrio
int desempilhar(struct _aluno v[], int &topo, struct _aluno &valor) {
    // Se a pilha est vazia... retorna 1
    if (topo<0) {
        cout << "ERRO: Pilha vazia!" << endl;
        return 1;
    }
    // Se pilha no est vazia, vamos desempilhar
    valor = v[topo];
    topo = topo - 1;
    // Indica que valor foi desempilhado
    return 0;
}


